OpenVDB: WenoStencil< GridT, IsSafe > Class Template Reference

OpenVDB 10.0.1

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Attributes | Protected Attributes | Friends | List of all members
WenoStencil< GridT, IsSafe > Class Template Reference

This is a special 19-point stencil that supports optimal fifth-order WENO upwinding, second-order central differencing, Laplacian, and zero-crossing test. More...

`#include <openvdb/math/Stencils.h>`

Inheritance diagram for WenoStencil< GridT, IsSafe >:

## Public Types
typedef GridT | GridType
typedef GridT::TreeType | TreeType
typedef GridType::ValueType | ValueType
typedef tree::ValueAccessor< const TreeType, IsSafe > | AccessorType
typedef std::vector< ValueType > | BufferType
typedef BufferType::iterator | IterType

## Public Member Functions
| WenoStencil (const GridType &grid)
| WenoStencil (const GridType &grid, Real dx)
ValueType | normSqGrad (const ValueType &isoValue=zeroVal< ValueType >()) const
| Return the norm-square of the WENO upwind gradient (computed via WENO upwinding and Godunov's scheme) at the previously buffered location.
math::Vec3< ValueType > | gradient (const math::Vec3< ValueType > &V) const
math::Vec3< ValueType > | gradient () const
ValueType | laplacian () const
bool | zeroCrossing () const
void | moveTo (const Coord &ijk)
| Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.
void | moveTo (const Coord &ijk, const ValueType &centerValue)
| Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors. The method also takes a value of the center element of the stencil, assuming it is already known.
template<typename IterType >
void | moveTo (const IterType &iter)
| Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.
template<typename RealType >
void | moveTo (const Vec3< RealType > &xyz)
| Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.
const ValueType & | getValue (unsigned int pos=0) const
| Return the value from the stencil buffer with linear offset pos.
template<int i, int j, int k>
const ValueType & | getValue () const
| Return the value at the specified location relative to the center of the stencil.
template<int i, int j, int k>
void | setValue (const ValueType &value)
| Set the value at the specified location relative to the center of the stencil.
int | size ()
| Return the size of the stencil buffer.
ValueType | median () const
| Return the median value of the current stencil.
ValueType | mean () const
| Return the mean value of the current stencil.
ValueType | min () const
| Return the smallest value in the stencil buffer.
ValueType | max () const
| Return the largest value in the stencil buffer.
const Coord & | getCenterCoord () const
| Return the coordinates of the center point of the stencil.
const ValueType & | getCenterValue () const
| Return the value at the center of the stencil.
bool | intersects (const ValueType &isoValue=zeroVal< ValueType >()) const
| Return true if the center of the stencil intersects the iso-contour specified by the isoValue.
std::bitset< 6 > | intersectionMask (const ValueType &isoValue=zeroVal< ValueType >()) const
| Return true a bit-mask where the 6 bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue.
const GridType & | grid () const
| Return a const reference to the grid from which this stencil was constructed.
const AccessorType & | accessor () const
| Return a const reference to the ValueAccessor associated with this Stencil.

## Static Public Attributes
static const int | SIZE = 19

## Protected Attributes
const GridType * | mGrid
Coord | mCenter

## Friends
template<typename , typename , bool >
class | BaseStencil

## Detailed Description

template<typename GridT, bool IsSafe = true>
class openvdb::v10_0::math::WenoStencil< GridT, IsSafe >

This is a special 19-point stencil that supports optimal fifth-order WENO upwinding, second-order central differencing, Laplacian, and zero-crossing test.

Note
  For optimal random access performance this class includes its own grid accessor.

## Member Typedef Documentation

## ◆ AccessorType

template<typename DerivedType , typename GridT , bool IsSafe>

typedef tree::ValueAccessor<const TreeType, IsSafe> AccessorType
| inherited

## ◆ BufferType

template<typename DerivedType , typename GridT , bool IsSafe>

typedef std::vector<ValueType> BufferType
| inherited

## ◆ GridType

template<typename GridT , bool IsSafe = true>

typedef GridT GridType

## ◆ IterType

template<typename DerivedType , typename GridT , bool IsSafe>

typedef BufferType::iterator IterType
| inherited

## ◆ TreeType

template<typename GridT , bool IsSafe = true>

typedef GridT::TreeType TreeType

## ◆ ValueType

template<typename GridT , bool IsSafe = true>

typedef GridType::ValueType ValueType

## Constructor & Destructor Documentation

## ◆ WenoStencil() [1/2]

template<typename GridT , bool IsSafe = true>

WenoStencil | ( | const GridType & | grid | ) |
| inline

## ◆ WenoStencil() [2/2]

template<typename GridT , bool IsSafe = true>

WenoStencil | ( | const GridType & | grid,
|  | Real | dx
| ) |  |
| inline

## Member Function Documentation

## ◆ accessor()

template<typename DerivedType , typename GridT , bool IsSafe>

const AccessorType & accessor | ( |  | ) | const
| inlineinherited

Return a const reference to the ValueAccessor associated with this Stencil.

## ◆ getCenterCoord()

template<typename DerivedType , typename GridT , bool IsSafe>

const Coord & getCenterCoord | ( |  | ) | const
| inlineinherited

Return the coordinates of the center point of the stencil.

## ◆ getCenterValue()

template<typename DerivedType , typename GridT , bool IsSafe>

const ValueType & getCenterValue | ( |  | ) | const
| inlineinherited

Return the value at the center of the stencil.

## ◆ getValue() [1/2]

template<typename DerivedType , typename GridT , bool IsSafe>
template<int i, int j, int k>

const ValueType & getValue | ( |  | ) | const
| inlineinherited

Return the value at the specified location relative to the center of the stencil.

## ◆ getValue() [2/2]

template<typename DerivedType , typename GridT , bool IsSafe>

const ValueType & getValue | ( | unsigned int | pos = `0` | ) | const
| inlineinherited

Return the value from the stencil buffer with linear offset pos.

Note
  The default (pos = 0) corresponds to the first element which is typically the center point of the stencil.

## ◆ gradient() [1/2]

template<typename GridT , bool IsSafe = true>

math::Vec3< ValueType > gradient | ( |  | ) | const
| inline

Return the gradient computed at the previously buffered location by second-order central differencing.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## ◆ gradient() [2/2]

template<typename GridT , bool IsSafe = true>

math::Vec3< ValueType > gradient | ( | const math::Vec3< ValueType > & | V | ) | const
| inline

Return the optimal fifth-order upwind gradient corresponding to the direction V.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## ◆ grid()

template<typename DerivedType , typename GridT , bool IsSafe>

const GridType & grid | ( |  | ) | const
| inlineinherited

Return a const reference to the grid from which this stencil was constructed.

## ◆ intersectionMask()

template<typename DerivedType , typename GridT , bool IsSafe>

std::bitset< 6 > intersectionMask | ( | const ValueType & | isoValue = `zeroVal<ValueType>()` | ) | const
| inlineinherited

Return true a bit-mask where the 6 bits indicates if the center of the stencil intersects the iso-contour specified by the isoValue.

Note
  There are 2^6 = 64 different possible cases, including no intersections!

The ordering of bit mask is ( -x, +x, -y, +y, -z, +z ), so to check if there is an intersection in -y use mask.test(2) where mask is ther return value from this function. To check if there are any intersections use mask.any(), and for no intersections use mask.none(). To count the number of intersections use mask.count().

## ◆ intersects()

template<typename DerivedType , typename GridT , bool IsSafe>

bool intersects | ( | const ValueType & | isoValue = `zeroVal<ValueType>()` | ) | const
| inlineinherited

Return true if the center of the stencil intersects the iso-contour specified by the isoValue.

## ◆ laplacian()

template<typename GridT , bool IsSafe = true>

ValueType laplacian | ( |  | ) | const
| inline

Return the Laplacian computed at the previously buffered location by second-order central differencing.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## ◆ max()

template<typename DerivedType , typename GridT , bool IsSafe>

ValueType max | ( |  | ) | const
| inlineinherited

Return the largest value in the stencil buffer.

## ◆ mean()

template<typename DerivedType , typename GridT , bool IsSafe>

ValueType mean | ( |  | ) | const
| inlineinherited

Return the mean value of the current stencil.

## ◆ median()

template<typename DerivedType , typename GridT , bool IsSafe>

ValueType median | ( |  | ) | const
| inlineinherited

Return the median value of the current stencil.

## ◆ min()

template<typename DerivedType , typename GridT , bool IsSafe>

ValueType min | ( |  | ) | const
| inlineinherited

Return the smallest value in the stencil buffer.

## ◆ moveTo() [1/4]

template<typename DerivedType , typename GridT , bool IsSafe>

void moveTo | ( | const Coord & | ijk | ) |
| inlineinherited

Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors.

Parameters

  ijk | Index coordinates of stencil center

## ◆ moveTo() [2/4]

template<typename DerivedType , typename GridT , bool IsSafe>

void moveTo | ( | const Coord & | ijk,
|  | const ValueType & | centerValue
| ) |  |
| inlineinherited

Initialize the stencil buffer with the values of voxel (i, j, k) and its neighbors. The method also takes a value of the center element of the stencil, assuming it is already known.

Parameters

  ijk | Index coordinates of stnecil center
  centerValue | Value of the center element of the stencil

## ◆ moveTo() [3/4]

template<typename DerivedType , typename GridT , bool IsSafe>
template<typename IterType >

void moveTo | ( | const IterType & | iter | ) |
| inlineinherited

Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.

Note
  This version is slightly faster than the one above, since the center voxel's value is read directly from the iterator.

## ◆ moveTo() [4/4]

template<typename DerivedType , typename GridT , bool IsSafe>
template<typename RealType >

void moveTo | ( | const Vec3< RealType > & | xyz | ) |
| inlineinherited

Initialize the stencil buffer with the values of voxel (x, y, z) and its neighbors.

Parameters

  xyz | Floating point voxel coordinates of stencil center

This method will check to see if it is necessary to update the stencil based on the cached index coordinates of the center point.

## ◆ normSqGrad()

template<typename GridT , bool IsSafe = true>

ValueType normSqGrad | ( | const ValueType & | isoValue = `zeroVal<ValueType>()` | ) | const
| inline

Return the norm-square of the WENO upwind gradient (computed via WENO upwinding and Godunov's scheme) at the previously buffered location.

Note
  This method should not be called until the stencil buffer has been populated via a call to moveTo(ijk).

## ◆ setValue()

template<typename DerivedType , typename GridT , bool IsSafe>
template<int i, int j, int k>

void setValue | ( | const ValueType & | value | ) |
| inlineinherited

Set the value at the specified location relative to the center of the stencil.

## ◆ size()

template<typename DerivedType , typename GridT , bool IsSafe>

int size | ( |  | ) |
| inlineinherited

Return the size of the stencil buffer.

## ◆ zeroCrossing()

template<typename GridT , bool IsSafe = true>

bool zeroCrossing | ( |  | ) | const
| inline

Return `true` if the sign of the value at the center point of the stencil differs from the sign of any of its six nearest neighbors

## Friends And Related Symbol Documentation

## ◆ BaseStencil

template<typename GridT , bool IsSafe = true>
template<typename , typename , bool >

friend class BaseStencil
| friend

## Member Data Documentation

## ◆ mCenter

template<typename DerivedType , typename GridT , bool IsSafe>

Coord mCenter
| protectedinherited

## ◆ mGrid

template<typename DerivedType , typename GridT , bool IsSafe>

const GridType* mGrid
| protectedinherited

## ◆ SIZE

template<typename GridT , bool IsSafe = true>

const int SIZE = 19
| static